| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | Static Public Member Functions | Protected Member Functions
Tp::Client::ChannelTypeTubesInterface Class Reference
Channel proxies

`#include <TelepathyQt/Channel>`

Inherits Tp::AbstractInterface.

List of all members.

## Public Slots

- QDBusPendingReply
  < Tp::SupportedSocketMap > GetAvailableStreamTubeTypes (int timeout=-1)
- QDBusPendingReply< Tp::UIntList > GetAvailableTubeTypes (int timeout=-1)
- QDBusPendingReply
  < Tp::TubeInfoList > ListTubes (int timeout=-1)
- QDBusPendingReply< uint > OfferDBusTube (const QString &service, const QVariantMap &parameters, int timeout=-1)
- QDBusPendingReply< uint > OfferStreamTube (const QString &service, const QVariantMap &parameters, uint addressType, const QDBusVariant &address, uint accessControl, const QDBusVariant &accessControlParam, int timeout=-1)
- QDBusPendingReply< QString > AcceptDBusTube (uint ID, int timeout=-1)
- QDBusPendingReply< QDBusVariant > AcceptStreamTube (uint ID, uint addressType, uint accessControl, const QDBusVariant &accessControlParam, int timeout=-1)
- QDBusPendingReply CloseTube (uint ID, int timeout=-1)
- QDBusPendingReply< QString > GetDBusTubeAddress (uint ID, int timeout=-1)
- QDBusPendingReply
  < Tp::DBusTubeMemberList > GetDBusNames (uint ID, int timeout=-1)
- QDBusPendingReply< uint,
  QDBusVariant > GetStreamTubeSocketAddress (uint ID, int timeout=-1)

## Signals

- void NewTube (uint ID, uint initiator, uint type, const QString &service, const QVariantMap &parameters, uint state)
- void TubeStateChanged (uint ID, uint state)
- void TubeClosed (uint ID)
- void DBusNamesChanged (uint ID, const Tp::DBusTubeMemberList &added, const Tp::UIntList &removed)
- void StreamTubeNewConnection (uint ID, uint handle)

## Public Member Functions

- ChannelTypeTubesInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
- ChannelTypeTubesInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
- ChannelTypeTubesInterface (Tp::DBusProxy *proxy)
- ChannelTypeTubesInterface (const Tp::Client::ChannelInterface &mainInterface)
- ChannelTypeTubesInterface (const Tp::Client::ChannelInterface &mainInterface, QObject *parent)
- Tp::PendingVariantMap * requestAllProperties () const

## Static Public Member Functions

- static QLatin1String staticInterfaceName ()

## Protected Member Functions

- virtual void invalidate (Tp::DBusProxy *, const QString &, const QString &)

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Channel.Type.Tubes".

## Constructor & Destructor Documentation

Tp::Client::ChannelTypeTubesInterface::ChannelTypeTubesInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ChannelTypeTubesInterface associated with the given object on the session bus.

Parameters:

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ChannelTypeTubesInterface::ChannelTypeTubesInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ChannelTypeTubesInterface associated with the given object on the given bus.

Parameters:

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ChannelTypeTubesInterface::ChannelTypeTubesInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a ChannelTypeTubesInterface associated with the same object as the given proxy.

Parameters:

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

Tp::Client::ChannelTypeTubesInterface::ChannelTypeTubesInterface | ( | const Tp::Client::ChannelInterface & | mainInterface | ) | `[explicit]`

Creates a ChannelTypeTubesInterface associated with the same object as the given proxy. Additionally, the created proxy will have the same parent as the given proxy.

Parameters:

  mainInterface | The proxy to use.

Tp::Client::ChannelTypeTubesInterface::ChannelTypeTubesInterface | ( | const Tp::Client::ChannelInterface & | mainInterface,
|  | QObject * | parent
| ) |  |

Creates a ChannelTypeTubesInterface associated with the same object as the given proxy. However, a different parent object can be specified.

Parameters:

  mainInterface | The proxy to use.
  parent | Passed to the parent class constructor.

## Member Function Documentation

static QLatin1String Tp::Client::ChannelTypeTubesInterface::staticInterfaceName | ( |  | ) | `[inline, static]`

Returns the name of the interface "org.freedesktop.Telepathy.Channel.Type.Tubes", which this class represents.

Returns:
  The D-Bus interface name.

Tp::PendingVariantMap* Tp::Client::ChannelTypeTubesInterface::requestAllProperties | ( |  | ) | const`[inline]`

Request all of the DBus properties on the interface.

Returns:
  A pending variant map which will emit finished when the properties have been retrieved.

QDBusPendingReply<Tp::SupportedSocketMap> Tp::Client::ChannelTypeTubesInterface::GetAvailableStreamTubeTypes | ( | int | timeout = `-1` | ) | `[inline, slot]`

Begins a call to the D-Bus method `GetAvailableStreamTubeTypes` on the remote object.

List the available address types and access-control types for stream tubes.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  timeout | The timeout in milliseconds.

Returns:

A mapping from address types (members of Socket_Address_Type) to arrays of access-control type (members of Socket_Access_Control) that the connection manager supports for stream tubes with that address type. For simplicity, if a CM supports offering a particular type of tube, it is assumed to support accepting it.

A typical value for a host without IPv6 support:

           {
             Socket_Address_Type_IPv4:
               [Socket_Access_Control_Localhost, Socket_Access_Control_Port,
                Socket_Access_Control_Netmask],
             Socket_Address_Type_Unix:
               [Socket_Access_Control_Localhost, Socket_Access_Control_Credentials]
           }

If stream tubes are not supported, this will be an empty dictionary.

QDBusPendingReply<Tp::UIntList> Tp::Client::ChannelTypeTubesInterface::GetAvailableTubeTypes | ( | int | timeout = `-1` | ) | `[inline, slot]`

Begins a call to the D-Bus method `GetAvailableTubeTypes` on the remote object.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  timeout | The timeout in milliseconds.

Returns:

An array of the available tube types, as defined by the Tube_Type enum.

QDBusPendingReply<Tp::TubeInfoList> Tp::Client::ChannelTypeTubesInterface::ListTubes | ( | int | timeout = `-1` | ) | `[inline, slot]`

Begins a call to the D-Bus method `ListTubes` on the remote object.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  timeout | The timeout in milliseconds.

Returns:

Return an array of tuples, each representing a tube, with the following members: the tube's ID the tube's initiator the tube's type the tube's service the tube's parameters the tube's state

QDBusPendingReply<uint> Tp::Client::ChannelTypeTubesInterface::OfferDBusTube | ( | const QString & | service,
|  | const QVariantMap & | parameters,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `OfferDBusTube` on the remote object.

Offers a D-Bus tube providing the service specified.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  service | A string representing the service name that will be used over the tube. It should be a well-known D-Bus service name, of the form com.example.ServiceName.
  parameters | A dictionary of properties for the new tube; the allowable keys, types and values are defined by the service. Connection managers must support the value being any primitive (non-container) D-Bus type, or a byte array 'ay'.
  timeout | The timeout in milliseconds.

Returns:

The ID of the new tube.

QDBusPendingReply<uint> Tp::Client::ChannelTypeTubesInterface::OfferStreamTube | ( | const QString & | service,
|  | const QVariantMap & | parameters,
|  | uint | addressType,
|  | const QDBusVariant & | address,
|  | uint | accessControl,
|  | const QDBusVariant & | accessControlParam,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `OfferStreamTube` on the remote object.

Offer a stream tube exporting the local socket specified.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  service | A string representing the service name that will be used over the tube. It should be a well-known TCP service name as defined by http://www.iana.org/assignments/port-numbers or http://www.dns-sd.org/ServiceTypes.html, for instance "rsync" or "daap".
  parameters | A dictionary of properties for the new tube; the allowable keys, types and values are defined by the service. Connection managers must support the value being any primitive (non-container) D-Bus type, or a byte array 'ay'. These should usually be the same key-value pairs specified for use in the DNS-SD TXT record for that service.
  addressType | The type of the listening address of the local service, as a member of Socket_Address_Type.
  address | The listening address of the local service, as indicated by the address_type.
  accessControl | The access control the local service applies to the local socket, specified so the connection manager can behave appropriately when it connects.
  accessControlParam | A parameter for the access control type, to be interpreted as specified in the documentation for the Socket_Access_Control enum.
  timeout | The timeout in milliseconds.

Returns:

The ID of the new tube.

QDBusPendingReply<QString> Tp::Client::ChannelTypeTubesInterface::AcceptDBusTube | ( | uint | ID,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `AcceptDBusTube` on the remote object.

Accept a D-Bus tube that's in the "local pending" state. The connection manager will attempt to open the tube. The tube remains in the "local pending" state until the TubeStateChanged signal is emitted.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  ID | The ID of the tube to accept.
  timeout | The timeout in milliseconds.

Returns:

The string describing the address of the private bus. The client should not attempt to connect to the address until the tube is open.

QDBusPendingReply<QDBusVariant> Tp::Client::ChannelTypeTubesInterface::AcceptStreamTube | ( | uint | ID,
|  | uint | addressType,
|  | uint | accessControl,
|  | const QDBusVariant & | accessControlParam,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `AcceptStreamTube` on the remote object.

Accept a stream tube that's in the "local pending" state. The connection manager will attempt to open the tube. The tube remains in the "local pending" state until the TubeStateChanged signal is emitted.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  ID | The ID of the tube to accept.
  addressType | The type of address the connection manager should listen on.
  accessControl | The type of access control the connection manager should apply to the socket.
  accessControlParam | A parameter for the access control type, to be interpreted as specified in the documentation for the Socket_Access_Control enum.
  timeout | The timeout in milliseconds.

Returns:

The address on which the connection manager will listen for connections to this tube. The client should not attempt to connect to the address until the tube is open.

QDBusPendingReply Tp::Client::ChannelTypeTubesInterface::CloseTube | ( | uint | ID,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `CloseTube` on the remote object.

Close a tube.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  ID | The ID of the tube to close.
  timeout | The timeout in milliseconds.

QDBusPendingReply<QString> Tp::Client::ChannelTypeTubesInterface::GetDBusTubeAddress | ( | uint | ID,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `GetDBusTubeAddress` on the remote object.

For a D-Bus tube, return a string describing the address of the private bus.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  ID | The ID of the tube to get an address for.
  timeout | The timeout in milliseconds.

Returns:

The bus address.

QDBusPendingReply<Tp::DBusTubeMemberList> Tp::Client::ChannelTypeTubesInterface::GetDBusNames | ( | uint | ID,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `GetDBusNames` on the remote object.

For a multi-user (i.e. Handle_Type_Room) D-Bus tube, obtain a mapping between contact handles and their unique bus names on this tube.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  ID | The ID of the tube to get names for.
  timeout | The timeout in milliseconds.

Returns:

An array of structures, each containing a contact handle and a D-Bus bus name.

QDBusPendingReply<uint, QDBusVariant> Tp::Client::ChannelTypeTubesInterface::GetStreamTubeSocketAddress | ( | uint | ID,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `GetStreamTubeSocketAddress` on the remote object.

For a stream tube, obtain the address of the socket used to communicate over this tube.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  ID | The ID of the stream tube to get the socket for.
  timeout | The timeout in milliseconds.

Returns:

The type of the listening address of the socket, as a member of Socket_Address_Type.

Returns:

The listening address of the socket, as indicated by the address_type.

void Tp::Client::ChannelTypeTubesInterface::NewTube | ( | uint | ID,
|  | uint | initiator,
|  | uint | type,
|  | const QString & | service,
|  | const QVariantMap & | parameters,
|  | uint | state
| ) |  | `[signal]`

Represents the signal `NewTube` on the remote object.

Emitted when a tube is created.

Parameters:

  ID | The ID of the new tube.
  initiator | The handle of the contact who initiated the tube.
  type | The tube type, as defined by the Tube_Type enum.
  service | A string representing the service that will be used over the tube.
  parameters | The new tube's properties.
  state | The new tube's state.

void Tp::Client::ChannelTypeTubesInterface::TubeStateChanged | ( | uint | ID,
|  | uint | state
| ) |  | `[signal]`

Represents the signal `TubeStateChanged` on the remote object.

Emitted when the state of a tube changes.

Parameters:

  ID | The ID of the tube that changed state.
  state | The new state of the tube; see the Tube_State enumeration.

void Tp::Client::ChannelTypeTubesInterface::TubeClosed | ( | uint | ID | ) | `[signal]`

Represents the signal `TubeClosed` on the remote object.

Emitted when a tube has been closed. The ID of a closed tube is no longer valid. The ID may later be reused for a new tube.

Parameters:

  ID | The ID of the tube that was closed.

void Tp::Client::ChannelTypeTubesInterface::DBusNamesChanged | ( | uint | ID,
|  | const Tp::DBusTubeMemberList & | added,
|  | const Tp::UIntList & | removed
| ) |  | `[signal]`

Represents the signal `DBusNamesChanged` on the remote object.

Emitted on a multi-user (i.e. Handle_Type_Room) D-Bus tube when a participant opens or closes the tube.

Parameters:

  ID | The ID of the tube whose names have changed.
  added | Array of handles and D-Bus names of new participants.
  removed | Array of handles of former participants.

void Tp::Client::ChannelTypeTubesInterface::StreamTubeNewConnection | ( | uint | ID,
|  | uint | handle
| ) |  | `[signal]`

Represents the signal `StreamTubeNewConnection` on the remote object.

Emitted on a stream tube when a participant opens a new connection to its socket.

Parameters:

  ID | The ID of the tube
  handle | The handle of the participant who opened the new connection

void Tp::Client::ChannelTypeTubesInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  | `[protected, virtual]`

Reimplemented from Tp::AbstractInterface.